<template>
  <div>
    <el-breadcrumb style="font-size: 24px; margin-top: 16px; margin-bottom: 32px;" separator=">">
      <el-breadcrumb-item v-if="currentTeachingClass(classId) !== undefined" :to="{ path: '/a/teacher/NNclass/'+classId }">{{ currentTeachingClass(classId).name }}</el-breadcrumb-item>
      <el-breadcrumb-item v-if="currentStudyingClass(classId) !== undefined" :to="{ path: '/a/teacher/NNclass/'+classId }">{{ currentStudyingClass(classId).name }}</el-breadcrumb-item>
      <el-breadcrumb-item v-if="currentPreviewClass(classId) !== undefined" :to="{ path: '/a/teacher/NNclass/'+classId }">{{ currentPreviewClass(classId).name }}</el-breadcrumb-item>
      <el-breadcrumb-item>{{ $t('CLASS_MENU.BOARD') }}</el-breadcrumb-item>
      <div style="text-align: right;">
        <a href="javascript:history.back();">
          <el-button size="small">{{ $t('ITEM_FROM_BANK.BACK') }}</el-button>
        </a>
      </div> 
    </el-breadcrumb>
    <el-input v-if="isPostOwner" :disabled="true" :value="name"></el-input>
    <el-input v-if="isPostOwner" :disabled="true" :value="content" type="textarea" :autosize="{ minRows: 10, maxRows: 15}"></el-input>
    <!-- 작성자 이외의 화면에서 el-input disable로 출력되어 불편 수정 190715 -->
    <div v-if="!isPostOwner" style="box-shadow: 0 2px 4px rgba(0, 0, 0, .12), 0 0 6px rgba(0, 0, 0, .04); width: 90%; padding: 5px;">{{ name }}</div>
    <div v-if="!isPostOwner" style="box-shadow: 0 2px 4px rgba(0, 0, 0, .12), 0 0 6px rgba(0, 0, 0, .04); width: 90%; padding: 5px; min-height: 200px;">{{ content }}</div>
    <el-button v-if="isPostOwner" @click="onClick('MODIFY')" plain>{{ $t('LECTURE_LIST.EDIT') }}</el-button>
    <el-button v-if="isPostOwner" @click="onClick('DELETEPOST')" type="danger" plain>{{ $t('LECTURE_LIST.DELETE') }}</el-button>
    <el-button @click="onClick('CANCEL')" plain>{{ $t('ITEM_FROM_BANK.BACK') }}</el-button>
    <p></p>
    <p></p>
    <div v-if="fileLength > 0">
      <hr>
      <h4>{{ $t('BOARD.ATTACH_FILE') }}</h4>
      <div :key="file.file_guid" v-for="file in post.files" style="margin: 20px 0px 20px 10px;">
        <span>{{ $t('MATERIAL.NAME') }} : {{ file.name }} </span>
        <el-button @click="onClick('DOWNLOAD',file.client_path,file.name)">{{ $t('DOWNLOAD.DOWN') }}</el-button>
      </div>
    </div>
    <hr>
    <div style="display: inline-block; width: 100%">
      <el-input v-model="comment" :placeholder="$t('BOARD.ENTER_COMM')"></el-input>
    </div>
    <el-button @click="onClick('SAVECOMMENT')" plain>{{ $t('BOARD.SAVE_COMM') }}</el-button>
    <div :key="reply.board_reply_id" v-for="reply in post.board_replies" style="margin: 20px 0px 20px 10px;">
      <span>{{ reply.user.name }}  :  {{ reply.content }}</span>
      <el-button v-if="reply.writer_id === jwtUserId" @click="onClick('DELETECOMMENT',reply.board_reply_id, reply.writer_id, jwtUserId)" type="danger" plain>X</el-button>
    </div>
  </div>
</template>

<script>
import { mapState, mapGetters, mapActions } from 'vuex';
import utils from '../../utils';
import { baseUrl } from '../../services/config';

export default {
  async created() {
    const vm = this;
    await vm.getPost({
      classId: vm.$route.params.classId,
      boardId: vm.$route.params.boardId,
    });
    vm.$data.name = vm.post.name;
    vm.$data.content = vm.post.content;
    vm.$data.fileLength = vm.post.files.length; // 직접 대입하면 url로 바로 호출시, undefined 오류가 발생하여(?) 임시처리
    vm.$data.jwtUserId = utils.getUserIdFromJwt();
    if (vm.post.writer_id === vm.$data.jwtUserId) {
      vm.$data.isPostOwner = true;
    }
  },
  computed: {
    ...mapState('board', [
      'post',
    ]),
    ...mapGetters('NNclass', [
      'currentTeachingClass',
      'currentStudyingClass',
      'currentPreviewClass',
    ]),
    classId() {
      const vm = this;
      return Number.parseInt(vm.$route.params.classId, 10);
    },
  },
  methods: {
    ...mapActions('board', [
      'getPost',
      'deletePost',
      'setModifyMode',
      'postReply',
      'deleteReply',
    ]),
    async onClick(type, arg, arg2) {
      const vm = this;
      switch (type) {
        case 'SAVECOMMENT': {
          await vm.postReply({
            boardId: this.$route.params.boardId,
            content: this.$data.comment,
          });
          this.$data.comment = '';
          break;
        }
        case 'CANCEL': {
          await vm.$router.go(-1);
          break;
        }
        case 'MODIFY': {
          vm.setModifyMode({
            flag: true,
          });
          await vm.$router.push(`/a/class/${this.$route.params.classId}/NNboardwrite`);
          break;
        }
        case 'DELETEPOST': {
          await vm.deletePost({
            classId: this.$route.params.classId,
            boardId: this.$route.params.boardId,
          });
          await vm.$router.go(-1);
          break;
        }
        case 'DELETECOMMENT': {
          await vm.deleteReply({
            boardId: this.$route.params.boardId,
            replyId: arg,
          });
          break;
        }
        default: {
          throw new Error(`not defined type ${type}`);
        }
        case 'DOWNLOAD': {
          utils.downloadFile(baseUrl, {
            client_path: arg,
            name: arg2
          });
          break;
        }
      }
    },
  },
  data() {
    return {
      name: '',
      content: '',
      comment: '',
      fileGuid: 'mock',
      isPostOwner: false,
      jwtUserId: '',
      fileLength: 0,
    };
  },
};
</script>